# Table of contents

* [Introduction](README.md)
* [What does DCli do?](what-does-dcli-do.md)
* [Install DCli](getting-started/README.md)
  * [Installing on Windows](getting-started/installing-on-windows.md)
* [Writing your first script](writing-your-first-script.md)
* [Add DCli to your project](added-dcli-to-your-project.md)
* [pub.dev](pub.dev.md)
* [github](github.md)

## Dart basics

* [Dart lambda functions](dart-basics/dart-lambda-functions.md)
* [Function Arguments](dart-basics/named-arguments.md)
* [Futures](dart-basics/futures.md)
* [stdin/stdout/stderr a primer](dart-basics/stdin-stdout-stderr.md)

## DCli API

* [Overview](dcli-api/overview.md)
* [Using DCli functions](dcli-api/using-dcli-functions.md)
* [User input](dcli-api/user-input.md)
* [Ask Validators](dcli-api/ask-validators.md)
* [Displaying information](dcli-api/displaying-information.md)
* [Managing Files And Directories](dcli-api/managing-files-and-directories.md)
* [Environment variables](dcli-api/environment-variables.md)
* [Calling apps](dcli-api/calling-apps.md)
* [Command Line Arguments](dcli-api/command-line-arguments.md)
* [Paths](dcli-api/paths.md)
* [Glob Expansion](dcli-api/glob-expansion.md)
* [Piping](dcli-api/piping.md)
* [Locking](dcli-api/locking.md)
* [Fetch](dcli-api/fetch.md)
* [The evils of CD](dcli-api/the-evils-of-cd.md)
* [Assets](dcli-api/assets.md)

## Dependency Management <a id="dependency-management-1"></a>

* [Dependency Management](dependency-management-1/dependency-management.md)
* [Pubspec Managment](dependency-management-1/pubspec-managment.md)

## DCli Tools <a id="dcli-tools-1"></a>

* [DCli tools](dcli-tools-1/dcli-tools.md)
* [Use a shebang \#!](dcli-tools-1/use-a-shebang.md)
* [DCli Compile](dcli-tools-1/dcli-compile.md)
* [DCli Clean](dcli-tools-1/dcli-clean-1.md)
* [DCli Create](dcli-tools-1/dcli-create.md)
* [DCli Doctor](dcli-tools-1/dcli-doctor.md)
* [DCli Install](dcli-tools-1/dcli-install.md)
* [DCli run](dcli-tools-1/dcli-run.md)
* [DCli Warmup](dcli-tools-1/dcli-clean.md)
* [Upgrade DCli](dcli-tools-1/upgrade-dcli.md)
* [Performance](dcli-tools-1/performance.md)
* [Docker](dcli-tools-1/docker.md)
* [Elevated Privileges](dcli-tools-1/elevated-privileges/README.md)
  * [Sudo](dcli-tools-1/elevated-privileges/sudo.md)

## Internal Workings

* [Internal Workings](internal-workings/internal-workings.md)
* [waitForEx](internal-workings/waitforex.md)

---

* [Contributing](contributing/README.md)
  * [Running Unit tests](contributing/running-unit-tests.md)
  * [Implemention support for a shell](contributing/implemention-support-for-a-shell.md)
* [Creating a release](creating-a-release.md)
* [References](references.md)

## Examples

* [Index](examples/overview/README.md)
  * [hello world.](examples/overview/hello-world..md)
  * [dcompress](examples/overview/dcompress.md)
  * [dpath](examples/overview/dpath.md)
  * [dmysql](examples/overview/dmysql.md)
  * [dshell](examples/overview/dshell.md)
  * [dwhich](examples/overview/dwhich.md)
  * [dipaddr](examples/overview/dipaddr.md)
  * [gnome launcher](examples/overview/untitled.md)

## Articles

* [Video: package of the week](articles/package-of-the-week.md)
* [build CLI apps in dart - part 1](articles/build-console-apps-in-dart.md)
* [build CLI apps in dart - part 2](articles/build-cli-apps-in-dart-part-2.md)

